import java.net.URI;
import java.net.URISyntaxException;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.logging.Level;
import java.util.logging.Logger;

public class Ch202PathCreation {
    public Ch202PathCreation() {
        pathCreationByString();
        pathCreationByURI();
    }

    private void pathCreationByString() {
        // リスト2.4 ディレクトリを指定したPathオブジェクトの生成
        Path path = Paths.get("foo", "bar.txt");

        // リスト2.5 絶対パスで指定したPathオブジェクトの生成 (Windows)
        // Path path = Paths.get("C:", "Users", "sakuraba");

        // リスト2.6 絶対パスで指定したPathオブジェクトの生成 (Linux/Mac)
        // Path path = Paths.get("/", "home", "sakuraba");

        // リスト2.7 ディレクトリを指定したPathオブジェクトの生成
        // Path path = Paths.get("foo" + File.separator + "bar.txt");
    }

    private void pathCreationByURI() {
        try {
            //リスト2.8 URIで指定したPathオブジェクトの生成
            Path path1 = Paths.get(new URI("file:/C:/Users/sakuraba"));
            Path path2 = Paths.get(new URI("file:/home/sakuraba"));
        } catch (URISyntaxException ex) {
            Logger.getGlobal().log(Level.SEVERE, "Wrong URI", ex);
        }
    }

    public static void main(String... args) {
        new Ch202PathCreation();
    }
}
