import java.net.URI;
import java.nio.file.Path;
import java.nio.file.Paths;

public class Ch203PathOperations {
    public static void main(String... args) {

        // リスト2.9 絶対パスへの変換
        Path relativePath = Paths.get("foo.txt");
        Path absolutePath = relativePath.toAbsolutePath();
        System.out.println(absolutePath);

        // リスト2.10 カレントディレクトリを含んだ相対パスを絶対パスへ変換
        Path relativePath2 = Paths.get("./foo.txt");
        Path absolutePath2 = relativePath2.toAbsolutePath();
        System.out.println(absolutePath2);

        // リスト2.11 冗長なパスを正規化
        Path relativePath3 = Paths.get("./foo.txt");
        relativePath3 = relativePath3.normalize();
        Path absolutePath3 = relativePath3.toAbsolutePath();
        System.out.println(absolutePath3);

        // リスト2.12 URIへの変換
        Path path = Paths.get("foo.txt");
        URI uri = path.toUri();
        System.out.println(uri);

        // リスト2.13 親パス、ルートパスの取得
        Path childPath = Paths.get("C:/foo/bar/baz");

        // 親パスの取得
        Path parentPath = childPath.getParent();
        System.out.println(parentPath);
        // ルートパスの取得
        Path rootPath = childPath.getRoot();
        System.out.println(rootPath);

        // リスト2.14 パス名の解決
        Path basePath = Paths.get("C:/foo");
        Path otherPath = Paths.get("bar/baz");
        Path subPath = basePath.resolve(otherPath);
        System.out.println(subPath);

    }
}
