import java.io.IOException;
import java.nio.file.FileSystem;
import java.nio.file.FileSystems;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.logging.Level;
import java.util.logging.Logger;

public class Ch204ZipFileSystem {
    public Ch204ZipFileSystem() {
        // コラムリスト ZIP/JARファイルに対応するファイルシステムの生成

        // ZIPファイルを表すPathオブジェクト
        Path zipfile = Paths.get("image.zip");

        // ZIPファイルに対応したファイルシステムの生成
        // ZIPファイルをオープンするため、try-with-resources構文で最後にクローズさせる
        try (FileSystem zipFS = FileSystems.newFileSystem(zipfile, ClassLoader.getSystemClassLoader())) {
            // ZIPファイルに含まれるiamge01.jpgファイルを表すPathオブジェクト
            Path image = zipFS.getPath("image01.jpg");

            // ファイルシステムを使用した操作
            System.out.println(image + " " + Files.exists(image));
        } catch (IOException ex) {
            Logger.getGlobal().log(Level.SEVERE, "Fail FileSystem Open", ex);
        }
    }

    public static void main(String... args) {
        new Ch204ZipFileSystem();
    }
}
