import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.nio.file.StandardCopyOption;
import java.util.logging.Level;
import java.util.logging.Logger;

public class Ch210FileReplace {

    public Ch210FileReplace() {
        try {
            replace();
        } catch (IOException ex) {
            Logger.getGlobal().log(Level.SEVERE, "File Move Fail", ex);
        }
    }

    private void replace() throws IOException {
        // リスト2.19 上書き可能なファイル名変更

        // 元のファイル名
        Path src = Paths.get("foo.txt");
        // 変更後のファイル名
        Path dest = Paths.get("bar.txt");

        // 上書き可能なファイル名変更
        Files.move(src, dest, StandardCopyOption.REPLACE_EXISTING);
    }

    public static void main(String... args) {
        new Ch210FileReplace();
    }
}
