import java.io.BufferedReader;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;

public class Ch219FileLoader {

    public Ch219FileLoader() {
        loadFile("foo.txt");
    }

    private void loadFile(String filename) {

        // リスト2.29 Files.newBufferedReaderメソッドを使用した、ファイルの読み込み

        // 読み込むファイル
        Path path = Paths.get(filename);

        // newBufferedReaderメソッドを使用して、BufferedReaderオブジェクトを取得
        try (BufferedReader reader = Files.newBufferedReader(path)) {
            List<String> contents = new ArrayList<>();

            for (;;) {
                String line = reader.readLine();
                if (line != null) {
                    contents.add(line);
                } else {
                    break;
                }
            }

            System.out.println(contents);
        } catch (IOException ex) {
            Logger.getGlobal().log(Level.SEVERE, "File Loading Fail", ex);
        }
    }

    public static void main(String... args) {
        new Ch219FileLoader();
    }
}
