import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;

public class Ch221SimpleFileSaver {
    public Ch221SimpleFileSaver() {
        try {
            List<String> contents = loadFile("foo.txt");

            saveFile("bar.txt", contents);
        } catch (IOException ex) {
            Logger.getGlobal().log(Level.SEVERE, "File I/O Fail", ex);
        }
    }

    private List<String> loadFile(String filename) throws IOException {
        Path path = Paths.get(filename);
        List<String> contents = Files.readAllLines(path);

        return contents;
    }

    private void saveFile(String filename, List<String> contents) throws IOException {
        // リスト2.31 簡易入出力メソッドによるファイル書き込み
        Path path = Paths.get(filename);
        Files.write(path, contents);
    }

    public static void main(String... args) {
        new Ch221SimpleFileSaver();
    }
}
