import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.nio.file.attribute.FileTime;
import java.nio.file.attribute.PosixFilePermission;
import java.nio.file.attribute.PosixFilePermissions;
import java.util.Set;
import java.util.logging.Level;
import java.util.logging.Logger;

public class Ch223SimpleAttributeWriter {

    public Ch223SimpleAttributeWriter() {
        try {
            writeAttribute();
        } catch (IOException ex) {
            Logger.getGlobal().log(Level.SEVERE, "Fail dealing Attribute", ex);
        }
    }

    private void writeAttribute() throws IOException {
        // リスト2.33 Filesクラスのアトリビュート設定メソッドの使用例

        // 対象となるパス
        Path path = Paths.get("foo.txt");

        // 最終変更日時を変更
        FileTime time = FileTime.fromMillis(System.currentTimeMillis());
        Files.setLastModifiedTime(path, time);

        // パーミッションを変更 (Windowsは不可)
        if (!System.getProperty("os.name").contains("Windows")) {
            Set<PosixFilePermission> permissions = PosixFilePermissions.fromString("rw-rw-rw-");
            Files.setPosixFilePermissions(path, permissions);
        }
    }

    public static void main(String... args) {
        new Ch223SimpleAttributeWriter();
    }
}
