import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.nio.file.attribute.FileTime;
import java.util.logging.Level;
import java.util.logging.Logger;

public class Ch224AttributeReader {

    public Ch224AttributeReader() {
        try {
            readAttribute();
        } catch (IOException ex) {
            Logger.getGlobal().log(Level.SEVERE, "Fail get Attribute", ex);
        }
    }

    private void readAttribute() throws IOException {
        // リスト2.34 アトリビュート名を指定してアトリビュートを取得

        // 対象となるパス
        Path path = Paths.get("foo.txt");

        // 最終変更日時を取得
        FileTime lastModifiy = (FileTime) Files.getAttribute(path, "lastModifiedTime");
        System.out.println("Last Modified Time: " + lastModifiy);

        // ファイルサイズを取得
        Long size = (Long) Files.getAttribute(path, "size");
        System.out.println("Size: " + size);
    }

    public static void main(String... args) {
        new Ch224AttributeReader();
    }
}
