import java.io.IOException;
import java.nio.file.FileVisitResult;
import java.nio.file.FileVisitor;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.nio.file.attribute.BasicFileAttributes;
import java.util.logging.Level;
import java.util.logging.Logger;

public class Ch228FileTreeWalk {

    public Ch228FileTreeWalk() {
        try {
            visitFiles();
        } catch (IOException ex) {
            Logger.getLogger(Ch228FileTreeWalk.class.getName()).log(Level.SEVERE, "Fail Walking File Tree", ex);
        }
    }

    private void visitFiles() throws IOException {
        // リスト2.41 ファイルツリーを走査するFileVisitor
        FileVisitor<Path> visitor = new FileVisitor<Path>() {
            @Override
            public FileVisitResult preVisitDirectory(Path dir, BasicFileAttributes attrs) {
                System.out.println("Pre Visit Directory: " + dir);

                return FileVisitResult.CONTINUE;
            }

            @Override
            public FileVisitResult visitFile(Path file, BasicFileAttributes attrs) {
                System.out.println("Visit File: " + file);

                return FileVisitResult.CONTINUE;
            }

            @Override
            public FileVisitResult postVisitDirectory(Path dir, IOException exc) {
                System.out.println("Post Visit Directory: " + dir);

                return FileVisitResult.CONTINUE;
            }

            @Override
            public FileVisitResult visitFileFailed(Path file, IOException exc) {
                System.out.println("Visit File Failed: " + file);

                return FileVisitResult.TERMINATE;
            }
        };

        // リスト2.42 ファイルツリーの走査
        Path path = Paths.get("alpha");
        Files.walkFileTree(path, visitor);
    }

    public static void main(String... args) {
        new Ch228FileTreeWalk();
    }
}
