import java.io.IOException;
import java.nio.file.FileVisitResult;
import java.nio.file.FileVisitor;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.nio.file.SimpleFileVisitor;
import java.nio.file.StandardCopyOption;
import java.nio.file.attribute.BasicFileAttributes;
import java.util.logging.Level;
import java.util.logging.Logger;

public class Ch229DirecotryCopy {
    public Ch229DirecotryCopy(String sourceDirectory, String destDirectory) {
        try {
            copyDirectory(sourceDirectory, destDirectory);
        } catch (IOException ex) {
            Logger.getLogger(Ch229DirecotryCopy.class.getName()).log(Level.SEVERE, "Failed Directory Coppy", ex);
        }
    }

    private void copyDirectory(String sourceDirectory, String destDirectory) throws IOException {
        // リスト2.43 ディレクトリのコピー

        // コピー元ディレクトリ
        Path source = Paths.get(sourceDirectory);
        // コピー先ディレクトリ
        Path dest = Paths.get(destDirectory);

        // ファイルツリーを辿って、ファイル・ディレクトリをコピーするFileVisitor
        FileVisitor<Path> visitor = new SimpleFileVisitor<Path>() {
            @Override
            public FileVisitResult preVisitDirectory(Path dir, BasicFileAttributes attrs)
                    throws IOException {
                // ディレクトリをコピー
                Files.copy(dir, dest.resolve(dir),
                           StandardCopyOption.COPY_ATTRIBUTES);

                return FileVisitResult.CONTINUE;
            }

            @Override
            public FileVisitResult visitFile(Path file, BasicFileAttributes attrs)
                    throws IOException {
                // ファイルをコピー
                Files.copy(file, dest.resolve(file),
                           StandardCopyOption.COPY_ATTRIBUTES);

                return FileVisitResult.CONTINUE;
            }
        };

        // ディレクトリのコピーを実行
        Files.walkFileTree(source, visitor);
    }

    public static void main(String... args) {
        if (args.length > 1) {
            new Ch229DirecotryCopy(args[0], args[1]);
        }
    }
}
