public class Ch303ReAbstraction {

    // デフォルトメソッド
    interface Greeting {

        default void sayTo(String person) {
            System.out.println("Nice to meet you, " + person + "!");
        }
    }

    // リスト3.25 デフォルトメソッドの再抽象化
    interface Regards extends Greeting {

        // メソッドを再抽象化する

        @Override
        void sayTo(String person);
    }

    private void testGreeting() {
        // 再抽象化したメソッドの実装を記述が必要
        Greeting greeting = new Regards() {
            @Override
            public void sayTo(String person) {
                System.out.println("How do you do, " + person + "?");
            }
        };

        // 再抽象化したメソッドのコール
        greeting.sayTo("Java");
    }

    public Ch303ReAbstraction() {
        testGreeting();
    }

    public static void main(String... args) {
        new Ch303ReAbstraction();
    }
}
