public class Ch304DefaultMethodOverride {

    // デフォルトメソッド
    interface Greeting {
        default void sayTo(String person) {
            System.out.println("Nice to meet you, " + person + "!");
        }
    }

    // リスト3.26 デフォルトメソッドのオーバーライド
    interface Hello extends Greeting {
        @Override
        default void sayTo(String person) {
            System.out.println("Hello, " + person + "!");
        }
    }

    private void testGreeting() {
        Greeting greeting = new Hello() {};

        // オーバーライドしたデフォルトメソッドのコール
        greeting.sayTo("Java SE");
    }

    public Ch304DefaultMethodOverride() {
        testGreeting();
    }

    public static void main(String... args) {
        new Ch304DefaultMethodOverride();
    }
}
