public class Ch305DiamondInheritance {

    // リスト3.27 ダイヤモンド継承問題
    interface Greeting {

        void sayTo(String person);
    }

    interface Hello extends Greeting {

        @Override
        default void sayTo(String person) {
            System.out.println("Hello, " + person + "!");
        }
    }

    interface Hi extends Greeting {

        @Override
        default void sayTo(String person) {
            System.out.println("Hi, " + person + "!");
        }
    }

    // NG
    // 同じシグネチャのデフォルトメソッドを継承しているため
    // コンパイルエラー
    //class CasualGreeting implements Hello, Hi {}

    // リスト3.28 コンパイルエラーの解消
    // 複数の同じシグネチャのデフォルトメソッドがある場合、
    // 必ずオーバーライドする
    class CasualGreeting implements Hello, Hi {

        @Override
        public void sayTo(String person) {
            System.out.println("Good Day, " + person + "!");
        }
    }

    private void testGreeting() {
        Greeting greeting = new CasualGreeting();

        greeting.sayTo("Japan");
    }

    public Ch305DiamondInheritance() {
        testGreeting();
    }

    public static void main(String... args) {
        new Ch305DiamondInheritance();
    }
}
