public class Ch307DefaultMethodCalll {

    // リスト3.30 複数のメソッド実装から一意にメソッドを指定してコールする

    interface Greeting {
        void sayTo(String person);
    }

    interface Hello extends Greeting {
        @Override
        default void sayTo(String person) {
            System.out.println("Hello, " + person + "!");
        }
    }

    interface Hi extends Greeting {
        @Override
        default void sayTo(String person) {
            System.out.println("Hi, " + person + "!");
        }
    }

    class CasualGreeting implements Hello, Hi {
        @Override
        public void sayTo(String person) {
            // HelloインタフェースのsayToメソッドをコール
            Hello.super.sayTo(person);
        }
    }

    private void testGreeting() {
        Greeting greeting = new CasualGreeting();

        // HelloクラスのsayToメソッドが使用される
        greeting.sayTo("Japan");
    }

    public Ch307DefaultMethodCalll() {
        testGreeting();
    }

    public static void main(String... args) {
        new Ch307DefaultMethodCalll();
    }
}
