import java.util.function.Consumer;

// リスト 3.36～3.37 クラスメソッド参照の例
public class Ch308ClassMethodReferenceDemo {

    public static void print(String text) {
        System.out.println(text);
    }

    public Ch308ClassMethodReferenceDemo() {
        // ラムダ式でstaticメソッドをコール
        Consumer<String> consumer1 = text -> Ch308ClassMethodReferenceDemo.print(text);
        consumer1.accept("Hello, World!");

        // クラスメソッド参照でstaticメソッドをコール
        Consumer<String> consumer2 = Ch308ClassMethodReferenceDemo::print;
        consumer2.accept("Hello, Java!");
    }

    public static void main(String... args) {
        new Ch308ClassMethodReferenceDemo();
    }
}
