import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.function.Consumer;

public class Ch309StrategyDemo {
    // リスト3.63 Envelopeクラス
    static class Envelope<T> {
        private T contents;
        
        private Envelope(T contents) {
            this.contents = contents;
        }
        
        public static <S> Envelope<S> create(S contents) {
            return new Envelope<S>(contents);
        }

        // リスト3.65 printメソッド
        public void print(Consumer<T> consumer) {
            consumer.accept(contents);
        }
    }
    
    public Ch309StrategyDemo() {
        // リスト3.64 Envelopeオブジェクトの生成例
        Envelope<String> container = Envelope.create("Hello, World!");
        
        // リスト3.66 SU printメソッドの使用例
                
        // 標準出力へ出力
        container.print(contents -> System.out.println(contents.toString()));

        // ファイルへ出力
        container.print(contents -> {
            try {
                Path path = Paths.get("contents.txt");
                Files.write(path, contents.toString().getBytes());
            } catch (IOException ex) {
                // 例外処理
            }
        });
    }
    
    public static void main(String... args) {
        new Ch309StrategyDemo();
    }
}
