import java.util.Arrays;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;

public class Ch310ComplexSortDemo {

    class Person {

        private String first;
        private String last;

        public Person(String first, String last) {
            this.first = first;
            this.last = last;
        }

        public String getFirst() {
            return first;
        }

        public String getLast() {
            return last;
        }

        public String toString() {
            return first + " " + last;
        }
    }

    public Ch310ComplexSortDemo() {
        List<Person> persons = Arrays.asList(
                new Person("James", "Brown"),
                new Person("David", "Crosby"),
                new Person("James", "Taylor"),
                new Person("Jackson", "Brown"),
                new Person("Neil", "Young"),
                new Person("Coco", "Taylor")
        );

        // リスト3.70 姓、名の順で比較を行うコンパレータ
//        Comparator<Person> comparator = (p1, p2) -> {
//            // 姓でソート
//            String last1 = p1.getLast();
//            String last2 = p2.getLast();
//            int result = last1.compareTo(last2);
//
//            if (result != 0) {
//                return result;
//            } else {
//                // 姓が同じ場合、名で比較
//                String first1 = p1.getFirst();
//                String first2 = p2.getFirst();
//                return first1.compareTo(first2);
//            }
//        };

        // リスト3.71 複合コンパレータ

        // 姓で比較
        Comparator<Person> lastComparator = (p1, p2) -> {
            String last1 = p1.getLast();
            String last2 = p2.getLast();

            return last1.compareTo(last2);
        };

        // 名で比較
        Comparator<Person> firstComparator = (p1, p2) -> {
            String first1 = p1.getFirst();
            String first2 = p2.getFirst();

            return first1.compareTo(first2);
        };

        // 姓で比較した後、名で比較する
        Comparator<Person> comparator = lastComparator.thenComparing(firstComparator);

        Collections.sort(persons, comparator);

        System.out.println(persons);
    }

    public static void main(String... args) {
        new Ch310ComplexSortDemo();
    }
}
