import java.util.function.BiConsumer;

// リスト3.38 複数の引数をとるクラスメソッド参照の例

public class MethodReferenceDemo2 {

    public static void print(Integer count, String text) {
        for (int i = 0; i < count; i++) {
            System.out.println(text);
        }
    }

    public MethodReferenceDemo2() {
        // ラムダ式でstaticメソッドをコール
        BiConsumer<Integer, String> consumer1 = (count, text) -> MethodReferenceDemo2.print(count, text);
        consumer1.accept(10, "Hello, World!");

        // クラスメソッド参照でstaticメソッドをコール
        BiConsumer<Integer, String> consumer2 = MethodReferenceDemo2::print;
        consumer2.accept(10, "Hello, Java!");
    }

    public static void main(String... args) {
        new MethodReferenceDemo2();
    }
}
