import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.stream.Collectors;

public class Customer {
    private final int id;
    private final String name;
    private final String area;
    private final List<Item> history;
    
    private Customer(int id, String name, String area, Item... purchases) {
        this.id = id;
        this.name = name;
        this.area = area;
        
        history = Arrays.stream(purchases)
                        .collect(Collectors.toList());
    }
    
    public static Customer of(int id, String name, String area, Item... purchases) {
        return new Customer(id, name, area, purchases);
    }
    
    public int getId() {
        return id;
    }

    public String getName() {
        return name;
    }
    
    public String getArea() {
        return area;
    }

    public List<Item> getHistory() {
        return new ArrayList(history);
    }
    
    @Override
    public String toString() {
        return "[" + id + ": " + name + "]";
    }
}
